/* proj2Database.java
 * This class provides methods to access the Oracle database via JDBC
 * API:  void open()
 * void find(String word )
 *    void close ()
 * Exceptions are printed.
 */
 
import java.sql.*;
import java.util.Properties;
import java.util.*;

 
class proj2Database {
 
  private Connection conn;
 
  public void open() {
    try {
      Class.forName("oracle.jdbc.driver.OracleDriver");
      conn = DriverManager.getConnection
 ("jdbc:oracle:thin:@carver.npac.syr.edu:1521:europe", "cy99wit",
"cy99wit");
      System.out.println("Connection Open");
    }
    catch (Exception e) { System.err.println("Error connection: " + e);}
  }

//find first and last place
  public Vector searchtrip(String first, String last ) {
 
    StringBuffer temp = new StringBuffer();//to hold airline
    StringBuffer total_tickets = new StringBuffer();//hold total tickets.
    Vector vect = new Vector();
    StringBuffer s1 = new StringBuffer();
    StringBuffer s2 = new StringBuffer();
    StringBuffer s3 = new StringBuffer();
    StringBuffer s4 = new StringBuffer();
    StringBuffer s5 = new StringBuffer();
    StringBuffer s6 = new StringBuffer();
    StringBuffer s7 = new StringBuffer();


 
    try {
      System.out.println("name passed = " + first + "," + last );
      // binding input parameters to SQL call
      PreparedStatement pstmt = conn.prepareStatement("select * from" +
      " trip where first = ? and last = ?");
      pstmt.setString(1,first);
      pstmt.setString( 2, last );

 // Execute the SQL, ResultSet is row(s) of data returned by database query
      ResultSet rs = null;
      rs = pstmt.executeQuery();
      // return the fields of the first row of the result set
      rs.next(); 
           s1.append( "Name:" );
           s1.append(rs.getString( 1 ));
           s1.append( ',' );
           s1.append(rs.getString( 2 ));
     System.out.println( "String s1 " );
     System.out.println( s1.toString() );

           vect.addElement( s1.toString() );
    System.out.println("Vector size:" + vect.size() ); 

           s2.append( "Style:" );
           temp.append( rs.getString( 3 ) ); 
           s2.append( temp.toString() );
           vect.addElement( s2.toString() );
System.out.println("Vector size:" + vect.size() );

           s3.append( "Price for ticket:" );
           total_tickets.append( rs.getString( 4 ) );
           s3.append( total_tickets.toString() );
           vect.addElement( s3.toString() );

    System.out.println("Vector size:" + vect.size() );
       
      // closing statement
      pstmt.close();
    }
    catch (Exception e) {
      e.printStackTrace();
    }

     try {
		 System.out.println("Trip condition: " + temp.toString() );
      // binding input parameters to SQL call
      String s ="select * from trip_add where" +
        " ADD_CONDITION= ?";
 
      PreparedStatement pstmta = conn.prepareStatement( s );
      pstmta.setString( 1,temp.toString() );
// Execute the SQL, ResultSet is row(s) of data returned by database query
      ResultSet rsa = null;
      rsa = pstmta.executeQuery();
      // return the fields of the first row of the result set
      rsa.next();

      s4.append("Schedule:" );
      s4.append(rsa.getString( 2 ));
      vect.addElement( s4.toString());
 
      s5.append( "Total price:$" );
      s5.append( Integer.parseInt( total_tickets.toString()) * rsa.getInt( 3 ));
      vect.addElement( s5.toString() );
      // closing statement
      pstmta.close();
    }
    catch (Exception e) {
      System.err.println("Error in dbase");
      e.printStackTrace();
    }
    return vect; 
  }
 
    public Vector searchcondition(String airn  ) {

    Vector vect = new Vector();
  
    try {
      System.out.println("Airline# passed = " + airn );
      // binding input parameters to SQL call
      String ss1 = "select * from" +
        " airline_schedule_price_table  where airline_number = ?";
      PreparedStatement pstmt = conn.prepareStatement( ss1 );
      pstmt.setString(1, airn);
  // Execute the SQL, ResultSet is row(s) of data returned by database query

      ResultSet rs = null;
      rs = pstmt.executeQuery();
      // return the fields of the first row of the result set
      rs.next();
      StringBuffer s1 = new StringBuffer( "First Place: " );
      s1.append(rs.getString( 1 ));
      vect.addElement( s1.toString() );
 
      StringBuffer s2 = new StringBuffer( "Last place: " );
      s2.append( rs.getString( 2 ) );
      vect.addElement( s2.toString() );
 
      StringBuffer s3 = new StringBuffer( "Trip condition:  " );
      s3.append(rs.getString( 3 ));
      vect.addElement( s3.toString() );	  	  StringBuffer s4 = new StringBuffer( "Total_pirce:$ " );
      s4.append( rs.getString( 4 ) );
      vect.addElement( s4.toString() );
      // closing statement
      pstmt.close();
    }
    catch (Exception e) {
      System.err.println("Error in dbase");
      e.printStackTrace();
    }
      return vect;
  }

//find meta data
/*  public Vector meta_Data() {
    
    Vector vect = new Vector();

    try{
      System.out.println("Find Meta data. "  );

      String s1 = "Select * from trip";
      Statement stmt = conn.createStatement();
      ResultSet rs = null;
      rs = stmt.executeQuery( s1 );  
      ResultSetMetaData rsmd = rs.getMetaData();
      
      for( int i = 1; i <= rsmd.getColumnCount(); i++ ){
        StringBuffer columnName = new StringBuffer("The column: ");
        columnName.append( i );
        columnName.append( " :" );
        columnName.append( rsmd.getColumnLabel( i ));
        vect.addElement( columnName );
       }
    }
    catch ( Exception ect ) 
    {
       System.out.println( "Error " + ect); 
     }
    return vect;
  }
*/


  public void updatetrip( String first, String last, String style,
                String price) {
    System.out.println( "Update trip:" + first);
    try{
     String s1 = "update  trip " + "set style = ?, "+           "price =?" + "where first = ? and last = ? ";
     PreparedStatement pstmt = conn.prepareStatement( s1 );
     pstmt.setString(1, style);
     pstmt.setInt(2, Integer.parseInt( price ));
     pstmt.setString(3, first);
     pstmt.setString(4, last);
 
    int r = pstmt.executeUpdate( s1 );
    pstmt.close();
    }//try
 
    catch( Exception e )
    { System.err.println("Error in dbase");
      e.printStackTrace();
    }
 
    }//updatetrip

   public void adddatetrip( String first, String last, String style,
             String price) {
    System.out.println( "Update Trip:" + first);
    try{
     String s1 = "insert into trip " + "(First, " +
   "Last, style, price)" + "values ( ?,?,?,?) ";
     PreparedStatement pstmt = conn.prepareStatement( s1 );
     pstmt.setString(1, first);
     pstmt.setInt(4, Integer.parseInt( price ));
     pstmt.setString(2, last);
     pstmt.setString(3, style);
 
    int r = pstmt.executeUpdate( s1 );
    pstmt.close();
    }//try
 
    catch( Exception e )
    { System.err.println("Error in dbase");
      e.printStackTrace();
    }
 
    }//adddatetrip
 
 
  public void delete_trip( String first, String last ) {
 
    System.out.println( "Delete date Client:" + first);
    try{
     String s1 = "delete from trip " +
     "where first = ? and last = ?";
     PreparedStatement pstmt = conn.prepareStatement( s1 );
     pstmt.setString(1, first);
     pstmt.setString(2, last);
 
    int r = pstmt.executeUpdate( s1 );
    pstmt.close();
    }//try
 
    catch( Exception e )
    { System.err.println("Error in dbase");
      e.printStackTrace();
    }
 
    }//delete_dateclient
 
  public void close() {
    try {
      conn.close();
      System.out.println("Connection Closed");
    }
    catch (Exception e) {System.err.println("Error in closing dbase");}
  }
}



